      SUBROUTINE SF23P(ARGR,ARGI,ANSR,ANSI,EPS,L,IERR)
      DIMENSION COEF(7),Z(2)
      INTEGER L,IERR,INT,LF1,LF2,LF3,J,IFOVFL,K,N
      DOUBLE PRECISION ARGR,ARGI,ANSR,ANSI,EPS,DABS,IDINT,DSIN,DMAX1,
     1DMIN1,DLOG,DATAN2,DEXP,DCOS,COEF,F0,F1,G0,G1,DELTA,DE0,DE1,ZZ1,W1,
     1W2,Y1,A,B,U,U1,U2,UU1,UU2,UUU1,UUU2,V1,V2,VV1,VV2,T1,T2,H,H1,H2,
     1AL1,AL2,DN,SYS001,SYS003,SYS025,SYS027,Z,SYS051,SYS053,SYS059
      DATA  COEF(1)/.6410256410256410D-2/,COEF(2)/-.1917526917526918D-2/
     1,COEF(3)/.8417508417508418D-3/,COEF(4)/-.5952380952380952D-3/,
     1COEF(5)/.7936507936507937D-3/,COEF(6)/-.2777777777777778D-2/,
     1COEF(7)/.8333333333333333D-1/,F0/840.0738529605262D0/,F1/
     120.00123082189420D0/,G0/1680.147705921052D0/,G1/
     1180.0147704705204D0/,SYS001/3.141592653589793D0/,SYS003/
     16.283185307179586D0/,SYS027/0.9189385332046727D0/,SYS025/
     11.837877066409345D0/,SYS051/1.1107652D-16/,SYS059/1.7D308/,
     1SYS053/1.7D308/
      IERR=0
      Z(1)=ARGR
      Z(2)=ARGI
      IF(Z(1).EQ.0.D0.AND.Z(2).EQ.0.D0) GO TO 6
      IF(Z(1).GT.0.D0) GO TO 1
      IF(Z(2).EQ.0.D0.AND.DABS(DBLE(FLOAT(IDINT(Z(1))))).EQ.
     *DABS(Z(1))) GO TO 6
    1 IF(L.EQ.0) GO TO 7
      IF(Z(1).NE.0.D0) GO TO 3
      IF(Z(2).LT.(-27.5D0)) GO TO 2
      IF(Z(2).LE.27.5D0) GO TO 7
    2 W1=0.D0
      W2=0.D0
      GO TO 27
    3 IF(Z(2).NE.0.D0) GO TO 7
      IF(Z(1).LE.408.909D0) GO TO 7
      IERR=65
    4 CALL UTSF11(IERR,23)
      GO TO 28
    5 IERR=66
      GO TO 4
    6 IERR=67
      GO TO 4
    7 DELTA=DABS(EPS)
      DE0=5.D0
      DE1=0.D0
      LF1=0
      IF(Z(2).GE.0.D0) GO TO 8
      LF1=1
      Z(2)=-Z(2)
    8 LF2=0
      IF(Z(1).GE.0.D0) GO TO 12
      LF2=1
      LF1=LF1-1
      T1=SYS025-SYS001*Z(2)
      T2=SYS001*(.5D0-Z(1))
      U=-SYS003*Z(2)
      IF(U.GE.(-.1054D0)) GO TO 10
      A=0.D0
      IF(U.LE.(-39.15D0)) GO TO 9
      A=DEXP(U)
    9 H1=1.D0-A
      GO TO 11
   10 U2=U*U
      A=-U*(F1*U2+F0)
      H1=(A+A)/((U2+G1)*U2+G0+A)
      A=1.D0-H1
   11 B=Z(1)-IDINT(Z(1)-.5D0)
      H2=A*DSIN(SYS003*B)
      B=DSIN(SYS001*B)
      H1=H1+(B+B)*B*A
      H=DABS(H2)+H1-SYS003*A*DELTA
      IF(H.LE.0.D0) GO TO 26
      DE0=DE0+DABS(T1)+T2
      DE1=SYS001+SYS003*A/H
      Z(1)=1.D0-Z(1)
   12 LF3=0
      Y1=Z(1)-.5D0
      W1=0.D0
      W2=0.D0
      K=0.D0
      B=DMAX1(.1D0,DMIN1(10.D0,14.142D0-Z(2)))-Z(1)
      IF(B.LE.0.D0) GO TO 19
      LF3=1
      ZZ1=Z(1)
      N=B+1.D0
      DN=N
      Z(1)=Z(1)+DN
      A=Z(1)*Z(1)+Z(2)*Z(2)
      V1=Z(1)/A
      V2=-Z(2)/A
      U1=1.D0-V1
      U2=-V2
      K=6.D0-Z(2)*.6D0-ZZ1
      IF(K.LE.0) GO TO 14
      N=N-K
      UU1=(ZZ1*Z(1)+Z(2)*Z(2))/A
      UU2=DN*Z(2)/A
      VV1=0.D0
      VV2=0.D0
      DO 13 J=1,K
      B=U1*(UU1+VV1)-U2*(UU2+VV2)
      U2=U1*(UU2+VV2)+U2*(UU1+VV1)
      U1=B
      VV1=VV1+V1
   13 VV2=VV2+V2
   14 IF(N.LE.1) GO TO 16
      VV1=V1
      VV2=V2
      DO 15 J=2,N
      VV1=VV1+V1
      VV2=VV2+V2
      B=U1*(1.D0-VV1)+U2*VV2
      U2=-U1*VV2+U2*(1.D0-VV1)
   15 U1=B
   16 U=U1*U1+U2*U2
      IF(U.EQ.0.D0) GO TO 26
      IF(L.EQ.0) GO TO 17
      IF(K.LE.0) GO TO 19
   17 AL1=DLOG(U)*.5D0
      IF(L.NE.0) GO TO 18
      W1=AL1
      W2=DATAN2(U2,U1)
      IF(W2.LT.0.D0) W2=W2+SYS003
      IF(K.LE.0) GO TO 19
   18 A=ZZ1+Z(2)-DELTA
      IF(A.LE.0.D0) GO TO 26
      DE0=DE0-AL1
      DE1=DE1+2.D0+1.D0/A
   19 A=Z(1)*Z(1)+Z(2)*Z(2)
      AL1=DLOG(A)*0.5D0
      AL2=DATAN2(Z(2),Z(1))
      V1=Y1*AL1-Z(2)*AL2
      V2=Y1*AL2+Z(2)*AL1
      VV1=0.D0
      VV2=0.D0
      IF(A.GT.SYS053) GO TO 21
      UU1=Z(1)/A
      UU2=-Z(2)/A
      UUU1=UU1*UU1-UU2*UU2
      UUU2=UU1*UU2*2.D0
      VV1=COEF(1)
      DO 20 J=2,7
      B=VV1*UUU1-VV2*UUU2
      VV2=VV1*UUU2+VV2*UUU1
   20 VV1=B+COEF(J)
      B=VV1*UU1-VV2*UU2
      VV2=VV1*UU2+VV2*UU1
      VV1=B
   21 W1=(((VV1+SYS027)-W1)-Z(1))+V1
      W2=((VV2-W2)-Z(2))+V2
      DE0=DE0+DABS(V1)+DABS(V2)
      IF(K.LE.0) DE1=DE1+AL1
      IF(LF2.NE.0) GO TO 22
      IF(L.EQ.0) GO TO 25
      A=DEXP(W1)
      W1=A*DCOS(W2)
      W2=A*DSIN(W2)
      IF(LF3.EQ.0) GO TO 25
      B=(W1*U1+W2*U2)/U
      W2=(W2*U1-W1*U2)/U
      W1=B
      GO TO 25
   22 H=H1*H1+H2*H2
      IF(H.EQ.0.D0) GO TO 26
      IF(L.EQ.0) GO TO 23
      IF(H.GT.1.D-2) GO TO 24
   23 A=DLOG(H)*.5D0
      IF(H.LE.1.D-2) DE0=DE0-A
      IF(L.NE.0) GO TO 24
      W1=(T1-A)-W1
      W2=(T2-DATAN2(H2,H1))-W2
      GO TO 25
   24 T1=T1-W1
      T2=T2-W2
      A=DEXP(T1)
      T1=A*DCOS(T2)
      T2=A*DSIN(T2)
      W1=(T1*H1+T2*H2)/H
      W2=(T2*H1-T1*H2)/H
      IF(LF3.EQ.0) GO TO 25
      B=W1*U1-W2*U2
      W2=W1*U2+W2*U1
      W1=B
   25 IF(LF1.NE.0) W2=-W2
      DE1=DE0*SYS051+3.D-17+DE1*DELTA
      GO TO 27
   26 W1=SYS059
      W2=SYS059
      DE1=SYS059
   27 ANSR=W1
      ANSI=W2
      EPS=DE1
      RETURN
   28 CONTINUE
      GO TO 26
      END
